
#include "queueUart.h"
#include "uart_dev.h"
#include "busIdleDetection.h"

/* ÿϢĴС */
#define QUEUE_SIZE 4

/* ͨѶڵĶ */
QueueHandle_t J1_485_Queue = NULL;
QueueHandle_t J2_485_Queue = NULL;
QueueHandle_t J3_485_Queue = NULL;
QueueHandle_t J4_485_Queue = NULL;
QueueHandle_t J5_0_485_Queue = NULL;
QueueHandle_t upward_uart_Queue = NULL;

/* м */
QueueSetHandle_t uart_Queue = NULL;

/* 鿴мǷ */
QueueSetMemberHandle_t xActivatedMember;

/* ͨýṹնӦͣͨýṹ壬ͷݵڴ */
typedef struct _queueRecvDataInfo {
    queueUartSendInfo *J1_485_data;
    queueUartSendInfo *J2_485_data;
    queueUartSendInfo *J3_485_data;
    queueUartSendInfo *J4_485_data;
    queueUartSendInfo *upward_uart_data;
    queueTimeShareSendInfo *J5_0_485_data;
} queueRecvDataInfo;
static queueRecvDataInfo queueRecvData;

/**
  * @brief  ʼڷ͵Ķ
  * @param  
  * @retval 
  */
void uartQueueInit(void)
{
    /* ʼ */
    J1_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J1_485_Queue) {
    //     log_error("creat J1_485_Queue error\n");
    // }

    J2_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J2_485_Queue) {
    //     log_error("creat J2_485_Queue error\n");
    // }
    
    J3_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J3_485_Queue) {
    //     log_error("creat J3_485_Queue error\n");
    // }
    
    J4_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J4_485_Queue) {
    //     log_error("creat J4_485_Queue error\n");
    // }
    
    J5_0_485_Queue = xQueueCreate(5, QUEUE_SIZE);
    // if (NULL == J5_0_485_Queue) {
    //     log_error("creat J5_0_485_Queue error\n");
    // }
    
    upward_uart_Queue = xQueueCreate(10, QUEUE_SIZE);
    // if (NULL == upward_uart_Queue) {
    //     log_error("creat upward_uart_Queue error\n");
    // }
    

    /* жм */
    uart_Queue = xQueueCreateSet(6);
    xQueueAddToSet(J1_485_Queue, uart_Queue);
    xQueueAddToSet(J2_485_Queue, uart_Queue);
    xQueueAddToSet(J3_485_Queue, uart_Queue);
    xQueueAddToSet(J4_485_Queue, uart_Queue);
    xQueueAddToSet(J5_0_485_Queue, uart_Queue);
    xQueueAddToSet(upward_uart_Queue, uart_Queue);
}

/**
  * @brief  Ӷȡݣͺ
  * @param  
  * @retval 
  */
void uartQueueSend(void)
{
    /* 鿴мǷ */
    xActivatedMember = xQueueSelectFromSet(uart_Queue, portMAX_DELAY);

    /* 鿴Upward_uart5 */
    if (!getUartState(g_Upward_uart5_handle)) {
        /* յ */
        if (xQueueReceive(upward_uart_Queue, &queueRecvData.upward_uart_data, 0) == pdTRUE) {
            uartInterruptSend(g_Upward_uart5_handle, queueRecvData.upward_uart_data->data
                    , queueRecvData.upward_uart_data->length);
        }
    }

    /* 鿴J1_485 */
    if (!getRs485State(g_J1_uart6_handle)) {
        /* յ */
        if (xQueueReceive(J1_485_Queue, &queueRecvData.J1_485_data, 0) == pdTRUE) {
            uartInterruptSend(g_J1_uart6_handle, queueRecvData.J1_485_data->data
                    , queueRecvData.J1_485_data->length);            
        }
    }

    /* 鿴J2_485 */
    if (!getRs485State(g_J2_uart7_handle)) {
        /* յ */
        if (xQueueReceive(J2_485_Queue, &queueRecvData.J2_485_data, 0) == pdTRUE) {
            uartInterruptSend(g_J2_uart7_handle, queueRecvData.J2_485_data->data
                    , queueRecvData.J2_485_data->length);            
        }
    }

    /* 鿴J3_485 */
    if (!getRs485State(g_J3_usart2_handle)) {
        /* յ */
        if (xQueueReceive(J3_485_Queue, &queueRecvData.J3_485_data, 0) == pdTRUE) {
            uartInterruptSend(g_J3_usart2_handle, queueRecvData.J3_485_data->data
                    , queueRecvData.J3_485_data->length);
        }
    }

    /* 鿴J4_485 */
    if (!getRs485State(g_J4_uart8_handle)) {
        /* յ */
        if (xQueueReceive(J4_485_Queue, &queueRecvData.J4_485_data, 0) == pdTRUE) {
            uartInterruptSend(g_J4_uart8_handle, queueRecvData.J3_485_data->data
                    , queueRecvData.J4_485_data->length);
        }
    }
    
    /* 鿴J5_0_485 */
    if (!getRs485State(g_J5_0_usart3_handle)) {
        /* յ */
        if (xQueueReceive(J5_0_485_Queue, &queueRecvData.J5_0_485_data, 0) == pdTRUE) {
            setConnectPort(queueRecvData.J5_0_485_data->connectPort);
            uartInterruptSend(g_J4_uart8_handle, queueRecvData.J5_0_485_data->data
                    , queueRecvData.J5_0_485_data->length);
        }
    }

}


#ifdef UARTINTERRUPTSEND
/**
  * @brief  ݷɺ
  * @param  
  * @retval 
  */
void J1_485_IN_TXE(void)
{
    vPortFree(queueRecvData.J1_485_data);
}


void J2_485_IN_TXE(void)
{
    vPortFree(queueRecvData.J2_485_data);
}


void J3_485_IN_TXE(void)
{
    vPortFree(queueRecvData.J3_485_data);
}


void J4_485_IN_TXE(void)
{
    vPortFree(queueRecvData.J4_485_data);
}


void J5_0_485_IN_TXE(void)
{
    vPortFree(queueRecvData.J5_0_485_data);
}


void Upward_USART_IN_TXE(void)
{
    vPortFree(queueRecvData.upward_uart_data);
}

#endif
